#! /usr/bin/python

#    col2res.py
#    Copyright (C) 2012
#    Authors: Arun I
#    email: theroarofthedragon@gmail.com

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.

import optparse

def resistance(rescolors):
	colorcode={"silver":-2,"gold":-1,"black":0,"brown":1,"red":2,"orange":3,"yellow":4,"green":5,"blue":6,"violet":7,"gray":8,"white":9}

	R=0
	for color in rescolors[0:-1]:
		R=R*10+colorcode[color.lower()]

	R=R*10**colorcode[rescolors[-1].lower()]

	return R

def tolerance(tolcolors):
	tolerancecode={"gray":0.05,"violet":0.1,"blue":0.25,"green":0.5,"brown":1,"red":2,"orange":3,"yellow":4,"gold":5,"silver":10,"none":20}
	tol=str(tolerancecode[tolcolors])+"%"
	return tol

def humanizeValue(value):
	modifier={-15:"f",-12:"p",-9:"n",-6:"u",-3:"m",0:"",3:"k",6:"M",9:"G",12:"T",15:"P"}
	exp=0
	while value>=1000:
		value=value/1000.0
		exp=exp+3
	while value<1:
		value=value*1000
		exp=exp-3
	value=str(value)+modifier[exp]
	return value

def numeralizeValue(value):
	exp={"f":-15,"p":-12,"n":-9,"u":-6,"m":-3,"":0,"k":3,"M":6,"G":9,"T":12,"P":15}
	modifier=value[-1]
	if modifier.isalpha():
		value=value[0:-1]
	else:
		modifier=""
	value=int(float(value)*10**exp[modifier])
	return value

#parsing command line arguments
parser=optparse.OptionParser(usage="%prog [options] colorcode",description="Script to convert color code of resistor to resistance value",\
epilog="Script written in Python by Nidhogg, the Red Dragon")
parser.add_option("-t","--tolerance",type="string",help="color of the tolerance ring")

(options,args)=parser.parse_args()
tolcolors=options.tolerance
rescolors=args[0].split(',')

#processing
R=resistance(rescolors)
if tolcolors!=None:
	tol=tolerance(tolcolors)

#printing results
print ""
print "Resistance:",humanizeValue(R)
if tolcolors!=None:
	print "Tolerance:",tol
print ""
